package sk.fiit.testframework.monitor;

import java.io.*;
import java.net.InetAddress;
import java.util.logging.Level;
import java.util.logging.Logger;

import org.junit.*;
import sk.fiit.testframework.geometry.Point3D;
import sk.fiit.testframework.parsing.models.PlayMode;
import sk.fiit.testframework.trainer.RobocupServerAddress;
import sk.fiit.testframework.trainer.Team;
import sk.fiit.testframework.trainer.Trainer;
import sk.fiit.testframework.trainer.testsuite.AgentJim;

import sk.fiit.testframework.worldrepresentation.ISimulationStateObserver;

public class MonitorTest {

    @Test
    public void test1() throws IOException {


        final Monitor monitor = new Monitor("127.0.0.1", 3200);
        RobocupServerAddress address =
                new RobocupServerAddress(InetAddress.getLocalHost(), 3100, 3200);

        Trainer t = new Trainer(address, monitor.socket);
        AgentJim jim = new AgentJim(address, new AgentJim.Data(10, Team.Left, 3070));

        t.setAgentPosition(jim, new Point3D(0.0, 0.0, 0.4));
        t.setPlayMode(PlayMode.PlayOn);
       t.setBall(new Point3D(0.5, 0.5, 0.5), new Point3D(1, 1, 1));

        monitor.getSimulationState().registerObserver(
                new ISimulationStateObserver() {

                    @Override
                    public void update() {
                        if (monitor.getSimulationState().getScene().getPlayers().size() > 0) {
//                            Player player = monitor.getSimulationState().getScene().getPlayers().get(0);

                            System.out.println("Ball: " + monitor.getSimulationState().getScene().getBallLocation());
                            System.out.println("Body:" + monitor.getSimulationState().getScene().getPlayers().get(0).getLocation());
                            System.out.println(monitor.getSimulationState().getScene().getPlayers().size());
//                    System.out.println(player.getBody().getHead().getTransformation().getValues()[12]);

                            //System.out.println(player.isOnGround());

                            //System.out.println(((NaoBody)player.getBody()).getHead().getTransformation().getValues()[14]);
                        }


                    }
                });
        try {
            System.out.println("start");
            monitor.start();
        } catch (IOException ex) {
            Logger.getLogger(MonitorTest.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    public static void main(String[] args) throws IOException {
        //test1();
    }
}
