/**
 * Name:    Main.java
 * Created: 19.5.2011
 * 
 * @author: Roman Kovac
 */
package sk.fiit.testframework.monitor.gui;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.JButton;

import sk.fiit.testframework.monitor.Monitor;
import sk.fiit.testframework.trainer.testsuite.TestCase;
import sk.fiit.testframework.worldrepresentation.ISimulationStateObserver;
import sk.fiit.testframework.worldrepresentation.models.Player;
import sk.fiit.testframework.worldrepresentation.models.Scene;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.IOException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * TODO: Replace with a brief purpose of class / interface.
 * 
 * @author Roman Kovac
 * 
 */
public class Main implements ISimulationStateObserver  {
	

	private JFrame frame;
	private ExecutorService executorService = Executors.newCachedThreadPool();
	private Monitor monitor;
	private JLabel lblBallX;
	private JLabel lblBallY;
	private JLabel lblLblagentx;
	private JLabel lblLblagenty;
	private JLabel lblLblagentz;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main window = new Main();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public Main() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frame = new JFrame();
		frame.setBounds(100, 100, 429, 295);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		JLabel lblLopta = new JLabel("Lopta");
		lblLopta.setFont(new Font("Stencil", Font.PLAIN, 14));

		JLabel lblX = new JLabel("X:");

		JLabel lblY = new JLabel("Y:");

		lblBallX = new JLabel("lblBallX");

		lblBallY = new JLabel("lblBallY");

		JButton btnStart = new JButton("Start");
		btnStart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				
			}
		});

		JButton btnStop = new JButton("Stop");
		
		JLabel lblHrac = new JLabel(" HRAC POZICIA");
		lblHrac.setFont(new Font("Stencil", Font.PLAIN, 14));
		
		JLabel lblX_1 = new JLabel("X:");
		
		JLabel lblY_1 = new JLabel("Y:");
		
		JLabel lblZ = new JLabel("Z:");
		
		lblLblagentx = new JLabel("lblAgentX");
		
		lblLblagenty = new JLabel("lblAgentY");
		
		lblLblagentz = new JLabel("lblAgentZ");
		
		
		GroupLayout groupLayout = new GroupLayout(frame.getContentPane());
		groupLayout.setHorizontalGroup(
			groupLayout.createParallelGroup(Alignment.LEADING)
				.addGroup(groupLayout.createSequentialGroup()
					.addContainerGap()
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addGroup(groupLayout.createSequentialGroup()
							.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
								.addComponent(lblLopta)
								.addGroup(groupLayout.createSequentialGroup()
									.addComponent(lblX)
									.addPreferredGap(ComponentPlacement.RELATED)
									.addComponent(lblBallX))
								.addGroup(groupLayout.createSequentialGroup()
									.addComponent(lblY)
									.addPreferredGap(ComponentPlacement.RELATED)
									.addComponent(lblBallY)))
							.addPreferredGap(ComponentPlacement.RELATED, 288, Short.MAX_VALUE)
							.addGroup(groupLayout.createParallelGroup(Alignment.TRAILING)
								.addComponent(btnStart)
								.addComponent(btnStop)))
						.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
							.addComponent(lblHrac, GroupLayout.PREFERRED_SIZE, 146, GroupLayout.PREFERRED_SIZE)
							.addGroup(groupLayout.createSequentialGroup()
								.addComponent(lblX_1)
								.addPreferredGap(ComponentPlacement.RELATED)
								.addComponent(lblLblagentx))
							.addGroup(groupLayout.createSequentialGroup()
								.addComponent(lblY_1)
								.addPreferredGap(ComponentPlacement.RELATED)
								.addComponent(lblLblagenty))
							.addGroup(groupLayout.createSequentialGroup()
								.addComponent(lblZ)
								.addPreferredGap(ComponentPlacement.RELATED)
								.addComponent(lblLblagentz))))
					.addContainerGap())
		);
		groupLayout.setVerticalGroup(
			groupLayout.createParallelGroup(Alignment.LEADING)
				.addGroup(groupLayout.createSequentialGroup()
					.addContainerGap()
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblLopta)
						.addComponent(btnStart))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addGroup(groupLayout.createSequentialGroup()
							.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
								.addComponent(lblX)
								.addComponent(lblBallX))
							.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
								.addComponent(lblY)
								.addComponent(lblBallY)))
						.addComponent(btnStop))
					.addGap(34)
					.addComponent(lblHrac, GroupLayout.PREFERRED_SIZE, 15, GroupLayout.PREFERRED_SIZE)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblX_1)
						.addComponent(lblLblagentx))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblY_1)
						.addComponent(lblLblagenty))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblZ)
						.addComponent(lblLblagentz))
					.addContainerGap(69, Short.MAX_VALUE))
		);
		frame.getContentPane().setLayout(groupLayout);
		
		startMonitor();
	}

	private void startMonitor() {
		monitor = new Monitor("127.0.0.1", 3200);
		monitor.getSimulationState().registerObserver(this);

        executorService.submit(new Runnable() {
            @Override
            public void run() {
                try {
                    monitor.start();
                } catch (IOException ex) {
                    System.out.println("monitor fail");
                }
            }
        });
	}

	
	@Override
	public void update() {
		Scene scene = monitor.getSimulationState().getScene();
		lblBallX.setText(Double.toString(scene.getBallLocation().getX()));
		lblBallY.setText(Double.toString(scene.getBallLocation().getY()));
		
		if (scene.getPlayers().size()>0) {
			Player player = scene.getPlayers().get(0);
			
			lblLblagentx.setText(Double.toString(player.getLocation().getX()));
			lblLblagenty.setText(Double.toString(player.getLocation().getY()));
			lblLblagentz.setText(Double.toString(player.getLocation().getZ()));
			
//			lblLblrotx.setText(Double.toString(player.getRotation().getX()));
//			lblLblroty.setText(Double.toString(player.getRotation().getY()));
//			lblLblrotz.setText(Double.toString(player.getRotation().getZ()));
		}
		
		
	}
}
