/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sk.fiit.testframework.trainer.testsuite;

import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;
import sk.fiit.testframework.annotations.Refactor;

import sk.fiit.testframework.annotations.UnderConstruction;
import sk.fiit.testframework.trainer.RobocupServerAddress;
import sk.fiit.testframework.trainer.Team;
import sk.fiit.testframework.trainer.testsuite.testcases.WalkTestCase;
import sk.fiit.testframework.trainer.testsuite.tester.TestCaseTester;

/**
 *
 * @author relation
 */
@UnderConstruction
@Refactor
public class WalkTestCaseTest {

    public static void main(String[] args) throws UnknownHostException, IOException {

        // define server's and monitor's addresses
        RobocupServerAddress address =
                new RobocupServerAddress(InetAddress.getLocalHost(), 3100, 3200);

        // we attach to an running agent jim
        AgentJim agentJim = new AgentJim(address,
                new AgentJim.Data(10, Team.Left, 3070));

        // we define a test case to test
        TestCase testCase = new WalkTestCase(address, agentJim);

        // we create a tester for test case
        TestCaseTester tester = new TestCaseTester(address, testCase);

        // print test case result
        System.out.println(tester.runOnce());

        // TODO: here comes machine learning module in terms of improving test results
    }

}
