/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sk.fiit.testframework.trainer.testsuite.testcases;

import java.io.IOException;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import sk.fiit.testframework.annotations.UnderConstruction;
import sk.fiit.testframework.geometry.Point3D;
import sk.fiit.testframework.monitor.Monitor;
import sk.fiit.testframework.trainer.RobocupServerAddress;
import sk.fiit.testframework.trainer.testsuite.TestCase;
import sk.fiit.testframework.trainer.testsuite.TestCaseResult;
import sk.fiit.testframework.worldrepresentation.models.SimulationState;

/**
 *
 * @author relation
 */
@UnderConstruction
public class TCEvaluationTest extends TestCase {

    private static Random rnd = new Random();

    public TCEvaluationTest(RobocupServerAddress address) throws IOException {
        super(address);
    }

    @Override
    public void init() {
        try {
            trainer.setBall(new Point3D(0, 0, 0.1), new Point3D(1, rnd.nextDouble(), rnd.nextDouble()));
        } catch (IOException ex) {
            throw new RuntimeException(ex);
        }
    }

    @Override
    public TestCaseResult evaluate(SimulationState ss) {
        final double desiredX = 1.0;
        return new TestCaseResult(ss.getScene().getBallLocation().getX() - desiredX);
    }

    @Override
    public boolean isStopCriterionMet(SimulationState ss) {
        System.out.println(getElapsedTime());
        if (ss.getScene().getBallLocation().getX() > 1) {
            return true;
        } else {
            return false;
        }
    }
}
