/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sk.fiit.testframework.trainer.testsuite.testcases;

import java.io.IOException;
import sk.fiit.testframework.geometry.Vector3;
import sk.fiit.testframework.parsing.models.PlayMode;
import sk.fiit.testframework.trainer.RobocupServerAddress;
import sk.fiit.testframework.trainer.testsuite.AgentJim;
import sk.fiit.testframework.trainer.testsuite.TestCase;
import sk.fiit.testframework.trainer.testsuite.TestCaseResult;
import sk.fiit.testframework.worldrepresentation.models.Player;
import sk.fiit.testframework.worldrepresentation.models.SimulationState;

/**
 *
 * @author relation
 */
public class WalkTestCase extends TestCase {

    private AgentJim agent;
    private Vector3 initPos;

    public WalkTestCase(RobocupServerAddress address, AgentJim agent) throws IOException {
        super(address);
        this.agent = agent;

        initPos = new Vector3(0.4, 0.4, 0.4);
    }

    @Override
    public void init() {
        try {
            trainer.setPlayMode(PlayMode.PlayOn);
            trainer.setAgentPosition(agent, initPos.asPoint3D());
        } catch (IOException ex) {
            throw new RuntimeException(ex);
        }
    }

    @Override
    public TestCaseResult evaluate(SimulationState ss) {
        System.out.println("evaluate()");
        Player p = ss.getScene().getPlayers().get(0);
        if (p.isOnGround()) {
            return new TestCaseResult(-1);
        } else {
//            return new TestCaseResult(1);
            return new TestCaseResult(initPos.getXYDistanceFrom(p.getLocation()));
        }
    }

    @Override
    public boolean isStopCriterionMet(SimulationState ss) {
        System.out.println("stopCriterion()");
        System.out.println(ss.getScene().getPlayers().size());
        Player p = ss.getScene().getPlayers().get(0);
        System.out.println(p.getLocation());
        if (p.isOnGround())
            return true;

        return false;
    }

}
